import java.io.*;

public class BinaerBaum{
    private Baumelement wurzel;
    
    public BinaerBaum() {
        wurzel = new Abschluss();
    }
    
    public void preOrder() {
        wurzel.preOrder();
    }
    
    public void inOrder() {
        wurzel.inOrder();
    }
        
    public void postOrder() {
        wurzel.postOrder();
    }
    
    public void insert(int datenNeu) {
        wurzel = wurzel.insert(datenNeu);
    }
    
    public void baumLeeren() {
        wurzel = new Abschluss();
    }
    
    public void baumAufbauen(String dateiName) {
        FileReader fr = null; 
        try {
            fr = new FileReader(dateiName); //Oeffnen der Datei
        } catch (FileNotFoundException e) {}
        BufferedReader br = new BufferedReader(fr); //Datenstrom-Steuerung
        //Ergebniszeichenkette
        String ergebnis = "";
        String zeile = "";
        //Hole die nchste Zeile, wenn diese ungleich NULL ist
        try {
            while( (zeile = br.readLine()) != null ) {
              //System.out.println(zeile);
              ergebnis += zeile;
            }
            br.close();
        } catch (IOException e) {}
        //String in Feld umwandeln
        String[] zwischenergebnis = ergebnis.split(",");
        int[] aktListe = new int[zwischenergebnis.length];
        for (int idx=0;idx<zwischenergebnis.length;idx++) {
            aktListe[idx] = Integer.parseInt(zwischenergebnis[idx]);
        }
        //baumaufbauen lassen
        baumAufbauen(aktListe,0,aktListe.length-1);
    }
    
    public void baumAufbauen(int[] aktListe, int startIdx, int endIdx) {
        if (endIdx-startIdx>0) { //Es gibt noch mindestens 1 Element
            int mitte = (int)((startIdx+endIdx)/2); //Mitte berechnen und abrunden
            
            //System.out.println("aktListe.get("+mitte+")):"+aktListe[mitte]);
            
            insert(aktListe[mitte]); //mittleres Element einfgen
            //Teillisten
            baumAufbauen(aktListe,startIdx,mitte-1);
            baumAufbauen(aktListe,mitte+1,endIdx);
        } else if (endIdx==startIdx) {
            //System.out.println("aktListe.get("+startIdx+")):"+aktListe[startIdx]);
            insert(aktListe[startIdx]);
        }
    }
    
    public void baumAusgleichen() {
        
    }
    
    @Override
    public String toString() {
        return wurzel.toString(new StringBuilder(), true, new StringBuilder()).toString();
    }
}
